// DrivePickerListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DrivePickerList.h"
#include "DrivePickerListDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrivePickerListDlg dialog

CDrivePickerListDlg::CDrivePickerListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDrivePickerListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDrivePickerListDlg)
	m_bShowHDs = FALSE;
	m_bShowCDs = FALSE;
	m_bShowOtherRemovables = FALSE;
	m_bShowNetDrives = FALSE;
	m_bShowRAMDisks = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDrivePickerListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDrivePickerListDlg)
	DDX_Control(pDX, IDC_LIST1, m_DrvList);
	DDX_Check(pDX, IDC_HARD_DISKS, m_bShowHDs);
	DDX_Check(pDX, IDC_CDROMS, m_bShowCDs);
	DDX_Check(pDX, IDC_OTHER_REMOVABLES, m_bShowOtherRemovables);
	DDX_Check(pDX, IDC_NET_DRIVES, m_bShowNetDrives);
	DDX_Check(pDX, IDC_RAM_DISKS, m_bShowRAMDisks);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDrivePickerListDlg, CDialog)
	//{{AFX_MSG_MAP(CDrivePickerListDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GET_SELECTION, OnGetSelection)
	//}}AFX_MSG_MAP
    ON_COMMAND_RANGE(IDC_SMALL_ICONS, IDC_LARGE_ICONS, OnChangeIcons)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrivePickerListDlg message handlers

BOOL CDrivePickerListDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDrivePickerListDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDrivePickerListDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDrivePickerListDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDrivePickerListDlg::OnChangeIcons ( UINT uID )
{
int nFlags = 0;

    UpdateData();

    if ( m_bShowHDs )
        nFlags |= DDS_DLIL_HARDDRIVES;

    if ( m_bShowCDs )
        nFlags |= DDS_DLIL_CDROMS;

    if ( m_bShowNetDrives )
        nFlags |= DDS_DLIL_NETDRIVES;

    if ( m_bShowOtherRemovables )
        nFlags |= DDS_DLIL_REMOVABLES;

    if ( m_bShowRAMDisks )
        nFlags |= DDS_DLIL_RAMDRIVES;


    m_DrvList.InitList ( uID == IDC_SMALL_ICONS ? 16 : 32, nFlags );
}

void CDrivePickerListDlg::OnGetSelection() 
{
BYTE  byNumSelectedDrives;
DWORD dwSelection;
TCHAR szSelection [27];
TCHAR szBitmask[33] = { 0 };
int   nCounter, nGroupCounter;

    byNumSelectedDrives = m_DrvList.GetNumSelectedDrives();
    m_DrvList.GetSelectedDrives ( &dwSelection );
    m_DrvList.GetSelectedDrives ( szSelection );

    SetDlgItemInt ( IDC_NUM_DRIVES, byNumSelectedDrives, FALSE );
    SetDlgItemText ( IDC_SELECTED_DRIVES, szSelection );

    for ( nCounter = 25, nGroupCounter = 4; nCounter >= 0; nCounter-- )
        {
        lstrcat ( szBitmask,
                  (dwSelection & (1 << nCounter)) ? _T("1") : _T("0") );

        if ( 5 == ++nGroupCounter )
            {
            lstrcat ( szBitmask, _T(" ") );
            nGroupCounter = 0;
            }
        }

    SetDlgItemText ( IDC_DRIVES_BITMASK, szBitmask );
}
